Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## sim.util.distribution
Class ChiSquare

    java.lang.Object
      sim.util.distribution.AbstractDistribution
          sim.util.distribution.AbstractContinousDistribution
              sim.util.distribution.ChiSquare

All Implemented Interfaces:
  java.io.Serializable

    public class ChiSquare

extends AbstractContinousDistribution

ChiSquare distribution; See the math definition and animated definition.

A special case of the Gamma distribution.

`p(x) = (1/g(f/2)) * (x/2)^(f/2-1) * exp(-x/2)` with `g(a)` being the gamma function and `f` being the degrees of freedom.

Valid parameter ranges: `freedom >= 0`.

Instance methods operate on a user supplied uniform random number generator; they are unsynchronized.

Static methods operate on a default uniform random number generator; they are synchronized.

Implementation:

Method: Ratio of Uniforms with shift.
High performance implementation. This is a port of RandChiSquare used in CLHEP 1.4.0 (C++). CLHEP's implementation, in turn, is based on `chru.c` from the C-RAND / WIN-RAND library. C-RAND's implementation, in turn, is based upon

J.F. Monahan (1987): An algorithm for generating chi random variables, ACM Trans. Math. Software 13, 168-172.

See Also:
  Serialized Form

Field Summary
`protected double` | `freedom`

Fields inherited from class sim.util.distribution.AbstractDistribution
`randomGenerator`

Constructor Summary
`ChiSquare(double freedom, MersenneTwisterFast randomGenerator)` Constructs a ChiSquare distribution.

Method Summary
`double` | `cdf(double x)` Returns the cumulative distribution function.
`double` | `nextDouble()` Returns a random number from the distribution.
`double` | `nextDouble(double freedom)` Returns a random number from the distribution; bypasses the internal state.
`double` | `pdf(double x)` Returns the probability distribution function.
`void` | `setState(double freedom)` Sets the distribution parameter.
`java.lang.String` | `toString()` Returns a String representation of the receiver.

Methods inherited from class sim.util.distribution.AbstractDistribution
`apply, apply, getRandomGenerator, nextInt, setRandomGenerator`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### freedom

    protected double freedom

Constructor Detail

### ChiSquare

    public ChiSquare(double freedom,
                     MersenneTwisterFast randomGenerator)

  Constructs a ChiSquare distribution. Example: freedom=1.0.

  Parameters:
    `freedom` - degrees of freedom.
  Throws:
    `java.lang.IllegalArgumentException` - if `freedom < 1.0`.

Method Detail

### cdf

    public double cdf(double x)

  Returns the cumulative distribution function.

### nextDouble

    public double nextDouble()

  Returns a random number from the distribution.

  Specified by:
    `nextDouble` in class `AbstractDistribution`

### nextDouble

    public double nextDouble(double freedom)

  Returns a random number from the distribution; bypasses the internal state.

  Parameters:
    `freedom` - degrees of freedom. It should hold `freedom < 1.0`.

### pdf

    public double pdf(double x)

  Returns the probability distribution function.

### setState

    public void setState(double freedom)

  Sets the distribution parameter.

  Parameters:
    `freedom` - degrees of freedom.
  Throws:
    `java.lang.IllegalArgumentException` - if `freedom < 1.0`.

### toString

    public java.lang.String toString()

  Returns a String representation of the receiver.

  Overrides:
    `toString` in class `java.lang.Object`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD